/*
	SambaScanner - A tool to scan Samba networks for files.
	Copyright (C) 2005-2006 Johannes Bauer
	
	This file is part of SambaScanner.

    SambaScanner is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; this program is ONLY licensed under
	version 2 of the License, later versions are explicitly excluded.

    SambaScanner is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SambaScanner; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Johannes Bauer
	Mussinanstr. 140
	92318 Neumarkt/Opf.
	JohannesBauer@gmx.de
*/

#define message(msglevel, args...) if (msglevel<=Options.DebugLvl) fprintf(stderr, args)

#ifndef DEFAULT_SMBCLIENT
#define DEFAULT_SMBCLIENT	"/usr/bin/smbclient"
#endif

#ifndef DEFAULT_NMBLOOKUP
#define DEFAULT_NMBLOOKUP	"/usr/bin/nmblookup"
#endif

#ifndef DEFAULT_SMBLISTER
#define DEFAULT_SMBLISTER	"/usr/bin/smblister"
#endif


struct Process {
	pid_t PID;
	pthread_t ThreadID;
	int Running;
	int Status;
	int Signal;			/* Was killed by signal? */
	int Valid;			/* Is the entered PID already valid? */
	double TermTime;
	double KillTime;
};

struct Options_Structure {
	double Timings;
	char Workgroup[256];
	int DebugLvl;
	char NmbLookup_Executable[256];
	char SmbClient_Executable[256];
	char SmbLister_Executable[256];
	char Outfile[256];
	int ThreadCount;
	int PreserveTemp;
} Options;

#define TEMPPATH			"/tmp/"
#define FILE_WORKGROUPINFO	(TEMPPATH "sambascanner_workgroup.tmp")
#define FILE_MASTERBROWSER	(TEMPPATH "sambascanner_masterbrowser.tmp")

#define BUFSIZE_SHORT		256
#define BUFSIZE				1024

#define VERSION				"0.14"

#define TIMEOUT_MIN			0.1
#define TIMEOUT_MAX			1000.0

